<?php
namespace Folha\Repositories;

class FpaEventoctbl extends \Doctrine\ORM\EntityRepository {

    public static function getAssociacaoContabilCompetencia ($nrorg, $nrorg_padrao, $dtmescompetencia, $nreventoctbl) {
        
        
        $sql = "
SELECT
  EVM.*,
  EVH.NMEVENTOH,
  EM.NMESTRUTURAM,
  CC.NMCONTCTBL AS NMCONTCTBLCRE,
  CD.NMCONTCTBL AS NMCONTCTBLDEB,
  HC.DSHISTPADR AS DSHISTPADRCRE,
  HD.DSHISTPADR AS DSHISTPADRDEB,
  D_ADM.DSDESPADMFAT,
  T_MV.NMTIPOMOVIMENT
FROM
  FPA_EVENTOCTBL EVM
  LEFT JOIN ESTRUTURAM EM ON ( EM.NRESTRUTURAM = EVM.NRESTRUTURAM
                               AND EVM.NRORG = EM.NRORG )
                               
  LEFT JOIN FPA_EVENTOH EVH ON (EVH.NREVENTOM = EVM.NREVENTOM
                                 AND (EVH.NRORG = EVM.NRORG
                                 OR EVH.NRORG =:P_NRORG_PADRAO) )
                               AND EVH.DTMESCOMPETENC = (SELECT
                                                           MAX(EVTH.DTMESCOMPETENC)
                                                         FROM
                                                           FPA_EVENTOH EVTH
                                                         WHERE
                                                           (EVTH.NRORG = EVH.NRORG
                                                             OR EVTH.NRORG =:P_NRORG_PADRAO)
                                                           AND EVTH.NREVENTOM = EVH.NREVENTOM
                                                           AND EVTH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                                                           
  LEFT JOIN CONTCTBL CC ON (CC.CDCONTCTBL = EVM.CDCONTCTBLCRE
                             AND CC.NRORG = EVM.NRORG )
                             
  LEFT JOIN CONTCTBL CD ON (CD.CDCONTCTBL = EVM.CDCONTCTBLDEB
                             AND (CD.NRORG = EVM.NRORG
                                  OR CD.NRORG = :P_NRORG_PADRAO) )
  
  LEFT JOIN HISTPADR HC ON (HC.CDHISTPADR = EVM.CDHISTPADRCRE
                             AND (HC.NRORG = EVM.NRORG
                                  OR HC.NRORG = :P_NRORG_PADRAO) )
  
  LEFT JOIN HISTPADR HD ON (HD.CDHISTPADR = EVM.CDHISTPADRDEB
                             AND (HD.NRORG = EVM.NRORG
                                  OR HD.NRORG = :P_NRORG_PADRAO) )
  
  LEFT JOIN DESPADMFATUR D_ADM ON (EVM.CDDESPADMFAT = D_ADM.CDDESPADMFAT
                                    AND EVM.NRORG = D_ADM.NRORG )
  
  LEFT JOIN FPA_TIPOMOVIMENT T_MV ON ( EVM.NRTIPOMOVIMENT = T_MV.NRTIPOMOVIMENT )
WHERE
  EVM.NRORG = :P_NRORG
  AND EVM.NREVENTOCTBL = :P_NREVENTOCTBL
        ";
        
        $query->execute(
            array(
                "P_NRORG"            => $nrorg,
                "P_NRORG_PADRAO"     => $nrorg_padrao,
                "P_DTMESCOMPETENC"   => $dtmescompetencia,
                "P_NREVENTOCTBL"     => $nreventoctbl
            )    
        );
        
        $result = $query->fetchAll();
        
        return $result;
    }
    
}