IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_SUP_LOGARQUINTEGRA' AND
                 TYPE = 'TR' 		        AND
	              U.UID = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_SUP_LOGARQUINTEGRA
GO


CREATE  TRIGGER LOG_SUP_LOGARQUINTEGRA
ON LOGARQUINTEGRA
FOR INSERT

AS
   DECLARE  @V_DESC                  VARCHAR(2000);
   DECLARE  @V_ITPESQ                VARCHAR(80);
   DECLARE  @V_TIPO                  VARCHAR(1);
   DECLARE  @V_NMOPERADOR            VARCHAR(40);
   DECLARE  @V_IDTIPOOPER            VARCHAR(1);
   DECLARE  @V_DTOPER                DATETIME;

   DECLARE  @V_ID_COMANDO            VARCHAR(1);
   DECLARE  @V_NEW_NMARQUIVO         VARCHAR(300);
   DECLARE  @V_NEW_LISTAOL           VARCHAR(200);
   DECLARE  @V_NEW_LISTAFILIAL       VARCHAR(200);
   DECLARE  @V_NEW_LISTASUBGRUPO     VARCHAR(50);
   DECLARE  @V_NEW_LISTATORA         VARCHAR(50);
   DECLARE  @V_NEW_DTPROGENPEOLINI   DATETIME;
   DECLARE  @V_NEW_DTPROGENPEOLFIN   DATETIME;
   DECLARE  @V_NEW_DTPROGEMBARQINI   DATETIME;
   DECLARE  @V_NEW_DTPROGEMBARQFIN   DATETIME;
   DECLARE  @V_NEW_LISTALOTE         VARCHAR(50);
   DECLARE  @V_NEW_CDPRODINI         VARCHAR(20);
   DECLARE  @V_NEW_CDPRODFIN         VARCHAR(20);


BEGIN
/* IDTIPOOPER - '1' - Incluso */

   SET @V_DESC         = '';
   SET @V_ITPESQ       = '';
   SET @V_NMOPERADOR   = '';
   SET @V_IDTIPOOPER   = '';

   EXEC NMUSUARIO @V_NMOPERADOR;

   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   DECLARE C_CURSOR CURSOR FOR
         SELECT
             'I' IDCOMANDO,
             INSERTED.NMARQUIVO,
             INSERTED.LISTAOL,
             INSERTED.LISTAFILIAL,
             INSERTED.LISTASUBGRUPO,
             INSERTED.LISTATORA,
             INSERTED.DTPROGENPEOLINI,
             INSERTED.DTPROGENPEOLFIN,
             INSERTED.DTPROGEMBARQINI,
             INSERTED.DTPROGEMBARQFIN,
             INSERTED.LISTALOTE,
             INSERTED.CDPRODINI,
             INSERTED.CDPRODFIN
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NEW_NMARQUIVO,
                                 @V_NEW_LISTAOL,
                                 @V_NEW_LISTAFILIAL,
                                 @V_NEW_LISTASUBGRUPO,
                                 @V_NEW_LISTATORA,
                                 @V_NEW_DTPROGENPEOLINI,
                                 @V_NEW_DTPROGENPEOLFIN,
                                 @V_NEW_DTPROGEMBARQINI,
                                 @V_NEW_DTPROGEMBARQFIN,
                                 @V_NEW_LISTALOTE,
                                 @V_NEW_CDPRODINI,
                                 @V_NEW_CDPRODFIN;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO= 'I' /*INSERTING*/ BEGIN
            IF @V_NEW_NMARQUIVO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Nm. arqu.:'  + @V_NEW_NMARQUIVO + ' ';
            END;
            IF @V_NEW_LISTAOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Lista OL:' + @V_NEW_LISTAOL + ' ';
            END;
            IF @V_NEW_LISTAFILIAL  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Lis. Fil.' + @V_NEW_LISTAFILIAL + ' ';
            END;
            IF @V_NEW_LISTASUBGRUPO  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Lista SubGr:' + @V_NEW_LISTASUBGRUPO  + ' ';
            END;
            IF @V_NEW_LISTATORA IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Lis. Rota:'  + @V_NEW_LISTATORA + ' ';
            END;
            IF @V_NEW_DTPROGENPEOLINI IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Entr. Ini.:'  + CONVERT(VARCHAR, @V_NEW_DTPROGENPEOLINI) + ' ';
            END;
            IF @V_NEW_DTPROGENPEOLFIN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Entr. Fin.:'  + CONVERT(VARCHAR, @V_NEW_DTPROGENPEOLFIN) + ' ';
            END;
            IF @V_NEW_DTPROGEMBARQINI IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Emb. Ini.:'  + CONVERT(VARCHAR, @V_NEW_DTPROGEMBARQINI) + ' ';
            END;
            IF @V_NEW_DTPROGEMBARQFIN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Emb. Fin.:'  + CONVERT(VARCHAR, @V_NEW_DTPROGEMBARQFIN) + ' ';
            END;
            IF @V_NEW_LISTALOTE IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Lis. Lote:' + @V_NEW_LISTALOTE + ' ';
            END;
            IF @V_NEW_CDPRODINI IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Prod Ini.:' + @V_NEW_CDPRODINI + ' ';
            END;
            IF @V_NEW_CDPRODFIN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Prod Fin.:' + @V_NEW_CDPRODFIN + ' ';
            END;

            SET  @V_TIPO   = '1';
            SET  @V_ITPESQ = SUBSTRING(@V_NEW_NMARQUIVO, 1, 80);
      END;
      EXEC NMUSUARIO @V_NMOPERADOR;
      SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');
      IF (@V_TIPO <> '0')  BEGIN
         IF @V_DESC IS NOT NULL BEGIN
            IF @V_NMOPERADOR IS NOT NULL BEGIN
               SET  @V_DTOPER = GETDATE();
               SET  @V_DESC = SUBSTRING(@V_DESC, 1, 400);
                  INSERT INTO LOGOPERA
                             (NMTABELA, DTOPERACAO, NMRESPOPER,
                              IDTIPOOPER, CDPESQITEM, DSOPERACAO)
                         VALUES
                             ('LOGARQUINTEGRA', @V_DTOPER, @V_NMOPERADOR,
                              @V_TIPO, @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NEW_NMARQUIVO,
                                 @V_NEW_LISTAOL,
                                 @V_NEW_LISTAFILIAL,
                                 @V_NEW_LISTASUBGRUPO,
                                 @V_NEW_LISTATORA,
                                 @V_NEW_DTPROGENPEOLINI,
                                 @V_NEW_DTPROGENPEOLFIN,
                                 @V_NEW_DTPROGEMBARQINI,
                                 @V_NEW_DTPROGEMBARQFIN,
                                 @V_NEW_LISTALOTE,
                                 @V_NEW_CDPRODINI,
                                 @V_NEW_CDPRODFIN;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_SUP_LOGARQUINTEGRA','5.50.xxx';
GO

